#include <windows.h>
#include <stdlib.h>
#include <process.h>
#include "dbf.h"

char	*cmp[]={
	"Order ID",
	"Tracking ID",
	"Registration Date",
	"Product Name",
	"Product ID",
	"Order Type",
	"Quantity",
	"Registration Total",
	"Name",
	"Company",
	"Email",
	"Address1",
	"Address2",
	"Address3",
	"City",
	"State",
	"Country  ",
	"Country Code",
	"Zip",
	"Phone",
	"UserName",
	"WhereFind"
	};


struct	Order {
	char	Order_ID[64];
	int 	Tracking_ID;
	char	Date[32];
	char	Product_Name[128];
	int 	Product_ID;
	char	Order_Type[64];
	int 	Quantity;
	double	Registration_Total;

	char	Name[128];
	char	Company[128];
	char	Email[128];
	char	Address1[128];
	char	Address2[128];
	char	Address3[128];
	char	City[128];
	char	State[128];
	char	Country[128];
	char    Country_Code[16];
	char	Zip[32];
	char	Phone[64];
	char	UserName[128];
	char	WhereFind[128];
	};


void
AddString(char	*s, char *b)
{
 char	*t;
 t=strchr(b,':');
 if (!t) s[0]='\0';
 else
 {
  ++t;
  while (*t==' ') ++t;
  strcpy(s, t);
 }
}

void
AddInt(int *x, char *b)
{
 char	*t;
 t=strchr(b,':');
 if (!t) x=0;
 else
 {
  ++t;
  while (*t==' ') ++t;
  *x=atoi(t);
 }
}

void
AddDouble(double *d, char *b)
{
 char	*t;
 t=strchr(b,':');
 if (!t) d=0;
 else
 {
  ++t;
  while (*t==' ') ++t;
  *d=atof(++t);
 }
}

void
AddDate(char *s, char *b)
{
 char	*t, *p;
 t=strchr(b,':');
 if (!t) s[0]='\0';
 else
 {
  ++t;
  while (*t==' ') ++t;
  p=strtok(t,"- \n");
  if (p) 
  {
   memcpy(&s[4], p, 2);
   p=strtok(NULL,"- \n");
   if (p) 
   {
    memcpy(&s[6], p, 2);
    p=strtok(NULL,"- \n");
    if (p) memcpy(s, p, 4);
   }
  }
 }
}



int
main(int argc, char* argv[])
{
 FILE		*in;
 char		*out;
 struct	DBF	*dbf;
 struct	Order	*order;
 char		buffer[128];
 char		path[MAX_PATH];
 int		l;


 if (argc<2)
 {
	puts("Order from RegSoft. Version 1.01 Copyright (c) Sergey Chehuta, 2001\n"
	     "Use:\n"
	     "\tOrder <filename.msg> [filename.dbf]\n"
		);
 }
 else
 {
	if (argc>2) out=argv[2]; else out="order.dbf";

	Init(0544631677-GetVerCDBFlib(0));

	order=(struct Order*)malloc(sizeof(struct Order));

	in=fopen(argv[1], "r");
	if (!in)
	{
	 printf("Can't open %s\n", argv[1]);
	 return 1;
	}

	dbf=(struct DBF*)malloc(sizeof(struct DBF));
	memset(dbf, 0, sizeof(struct DBF));
	SetDefOptions(dbf);
	dbf->h=Open_File(out);
	if (dbf->h)
	 if (ReadHeader(dbf))
	 {
	  dbf->filename=strdup(out);
	  if (ReadFields(dbf))
	  {

           while( fgets( buffer, 128, in ) != NULL )
           {
  	    l=strlen(buffer);
  	    if (l && buffer[l-1]=='\n') buffer[l-1]='\0';
            if (!strnicmp(buffer,  cmp[0],  strlen(cmp[0])))  AddString(order->Order_ID,	buffer);
            if (!strnicmp(buffer,  cmp[1],  strlen(cmp[1])))  AddInt   (&order->Tracking_ID,	buffer);
            if (!strnicmp(buffer,  cmp[2],  strlen(cmp[2])))  AddDate  (order->Date,		buffer);
            if (!strnicmp(buffer,  cmp[3],  strlen(cmp[3])))  AddString(order->Product_Name,	buffer);
            if (!strnicmp(buffer,  cmp[4],  strlen(cmp[4])))  AddInt   (&order->Product_ID,	buffer);
            if (!strnicmp(buffer,  cmp[5],  strlen(cmp[5])))  AddString(order->Order_Type,	buffer);
            if (!strnicmp(buffer,  cmp[6],  strlen(cmp[6])))  AddInt   (&order->Quantity,	buffer);
            if (!strnicmp(buffer,  cmp[7],  strlen(cmp[7])))  AddDouble(&order->Registration_Total,buffer);
            if (!strnicmp(buffer,  cmp[8],  strlen(cmp[8])))  AddString(order->Name,		buffer);
            if (!strnicmp(buffer,  cmp[9],  strlen(cmp[9])))  AddString(order->Company,		buffer);
            if (!strnicmp(buffer,  cmp[10], strlen(cmp[10]))) AddString(order->Email,		buffer);
            if (!strnicmp(buffer,  cmp[11], strlen(cmp[11]))) AddString(order->Address1,	buffer);
            if (!strnicmp(buffer,  cmp[12], strlen(cmp[12]))) AddString(order->Address2,	buffer);
            if (!strnicmp(buffer,  cmp[13], strlen(cmp[13]))) AddString(order->Address3,	buffer);
            if (!strnicmp(buffer,  cmp[14], strlen(cmp[14]))) AddString(order->City,		buffer);
            if (!strnicmp(buffer,  cmp[15], strlen(cmp[15]))) AddString(order->State,		buffer);
            if (!strnicmp(buffer,  cmp[16], strlen(cmp[16]))) AddString(order->Country,		buffer);
            if (!strnicmp(buffer,  cmp[17], strlen(cmp[17]))) AddString(order->Country_Code,	buffer);
            if (!strnicmp(buffer,  cmp[18], strlen(cmp[18]))) AddString(order->Zip,		buffer);
            if (!strnicmp(buffer,  cmp[19], strlen(cmp[19]))) AddString(order->Phone,		buffer);
            if (!strnicmp(buffer,  cmp[20], strlen(cmp[20]))) AddString(order->UserName,	buffer);
            if (!strnicmp(buffer,  cmp[21], strlen(cmp[21]))) AddString(order->WhereFind,	buffer);

	   }
	   fclose(in);

	   ClearRecord(dbf);
	   SetString (dbf, 0,  order->Order_ID         );
           SetNumeric(dbf, 1,  order->Tracking_ID      );
           SetString (dbf, 2,  order->Date             );
           SetString (dbf, 3,  order->Product_Name     );
           SetNumeric(dbf, 4,  order->Product_ID       );
           SetString (dbf, 5,  order->Order_Type       );
           SetNumeric(dbf, 6,  order->Quantity	       );
           SetFloat  (dbf, 7,  order->Registration_Total);
           SetString (dbf, 8,  order->Name             );
           SetString (dbf, 9,  order->Company          );
           SetString (dbf, 10, order->Email            );
           SetString (dbf, 11, order->Address1         );
           SetString (dbf, 12, order->Address2         );
           SetString (dbf, 13, order->Address3         );
           SetString (dbf, 14, order->City             );
           SetString (dbf, 15, order->State            );
           SetString (dbf, 16, order->Country          );
           SetString (dbf, 17, order->Country_Code     );
           SetString (dbf, 18, order->Zip              );
           SetString (dbf, 19, order->Phone            );
           SetString (dbf, 20, order->UserName         );
           SetString (dbf, 21, order->WhereFind        );
	   AppendBlank(dbf, FALSE);

	   dbf->opt.trimspace=3;
	   GetString(dbf, 20);
	   if (!dbf->str[0]) GetString(dbf, 8);

	   switch (order->Product_ID)
	   {
	    case 39573:		//cdbfapi.dll
			// some actions...
	    	break;
	    case 39576:		//cdbfapi.dll src
			// some actions...
	    	break;
//	    case 39576:	
//
//	    	break;
	   }

	   }
	   Close_File(dbf);
	   return 0;
	  }
	printf("Can't open %s\n", out);
 }
 return 1;
}
